/*
* Far Named Folders 2.x
* Copyright (c) 2002-2004 by Victor Derevyanko, RAMMuS Group
* www: http://www.rammus.ru
* e-mail: wingspan@yandex.ru
*/
#pragma once

#include "Kernel.h"
#include "codec_for_values.h"

namespace nf 
{

//  (    )
	bool ExecuteCommand(kr::tparsed_command &cmd);

//   /  
	bool select_required_shortcut(HANDLE hPlugin, kr::tparsed_command const &cmd, kr::tshortcut_info& sh);
	bool select_required_catalog(HANDLE hPlugin, kr::tparsed_command const &cmd, kr::tcatalog_info& c);
	bool select_required_path(HANDLE hPlugin
		, nf::tshortcut_value_parsed const &Value
		, tstring const& PathPattern
		, tstring &ResultPath);

//    /
	bool open_shortcut(HANDLE hPlugin
		, kr::tshortcut_info const& sh
		, tstring const &path
		, bool bOpenOnActivePanel = true);
	bool open_shortcut_in_explorer(HANDLE hPlugin
		, kr::tshortcut_info const& sh
		, tstring const &path);
	bool open_specified_path(HANDLE hPlugin
		, tstring const& path);

	bool delete_shortcut(HANDLE hPlugin, kr::tshortcut_info const& sh, bool bImplicit);
	bool delete_catalog(HANDLE hPlugin, kr::tcatalog_info const& cat);

//  
	bool add_shortcut(HANDLE hPlugin, kr::tshortcut_info const &sh, TCHAR const* value, bool bImplicit);
	bool add_shortcut(HANDLE hPlugin, kr::tcatalog_info const &cat, tstring const& sh, bool bTemporary, bool bImplicit);
	bool add_shortcut_both(HANDLE hPlugin, kr::tcatalog_info const &cat, tstring const& sh, bool bTemporary, bool bImplicit);
	
	bool add_catalog(HANDLE hPlugin, kr::tcatalog_info const &cat);


	bool get_implicit_name_and_value(HANDLE hPlugin
		, bool bGetDataFromActivePanel	//      
		, tstring &name
		, tstring &value);
};